/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.system.swing;

//TODO: find some solution to avoid such mistakes like UIManager.get(UManagerKey.activeCaption)  - now, proper usage needs to be UIManager.get(UManagerKey.activeCaption.getKey())

import java.util.Enumeration;
import javax.swing.UIDefaults;
import javax.swing.UIManager;

/**
 * UIManager keys widely used in L&Fs.
 * Important: You need to use {@code getKey} method for proper usage in UIManager.get/put (due to using Object as a key)
 *
 * This set is taken from {@code UIManager.getDefaults().keys()} with default L&F.
 * Additional keys are added
 *
 * @author szpak
 */
public enum UIManagerKey
{

    activeCaption("activeCaption"),
    activeCaptionBorder("activeCaptionBorder"),
    activeCaptionText("activeCaptionText"),
    AuditoryCues_allAuditoryCues("AuditoryCues.allAuditoryCues"),
    AuditoryCues_cueList("AuditoryCues.cueList"),
    AuditoryCues_defaultCueList("AuditoryCues.defaultCueList"),
    AuditoryCues_noAuditoryCues("AuditoryCues.noAuditoryCues"),
    Button_background("Button.background"),
    Button_border("Button.border"),
    Button_darkShadow("Button.darkShadow"),
    Button_defaultButtonFollowsFocus("Button.defaultButtonFollowsFocus"),
    Button_disabledText("Button.disabledText"),
    Button_disabledToolBarBorderBackground("Button.disabledToolBarBorderBackground"),
    Button_focus("Button.focus"),
    Button_focusInputMap("Button.focusInputMap"),
    Button_font("Button.font"),
    Button_foreground("Button.foreground"),
    Button_gradient("Button.gradient"),
    Button_highlight("Button.highlight"),
    Button_light("Button.light"),
    Button_margin("Button.margin"),
    Button_rollover("Button.rollover"),
    Button_rolloverIconType("Button.rolloverIconType"),
    Button_select("Button.select"),
    Button_shadow("Button.shadow"),
    Button_textIconGap("Button.textIconGap"),
    Button_textShiftOffset("Button.textShiftOffset"),
    Button_toolBarBorderBackground("Button.toolBarBorderBackground"),
    ButtonUI("ButtonUI"),
    CheckBox_background("CheckBox.background"),
    CheckBox_border("CheckBox.border"),
    CheckBox_disabledText("CheckBox.disabledText"),
    CheckBox_focus("CheckBox.focus"),
    CheckBox_focusInputMap("CheckBox.focusInputMap"),
    CheckBox_font("CheckBox.font"),
    CheckBox_foreground("CheckBox.foreground"),
    CheckBox_gradient("CheckBox.gradient"),
    CheckBox_icon("CheckBox.icon"),
    CheckBox_margin("CheckBox.margin"),
    CheckBox_rollover("CheckBox.rollover"),
    Checkbox_select("Checkbox.select"),
    CheckBox_textIconGap("CheckBox.textIconGap"),
    CheckBox_textShiftOffset("CheckBox.textShiftOffset"),
    CheckBox_totalInsets("CheckBox.totalInsets"),
    CheckBoxMenuItem_acceleratorFont("CheckBoxMenuItem.acceleratorFont"),
    CheckBoxMenuItem_acceleratorForeground("CheckBoxMenuItem.acceleratorForeground"),
    CheckBoxMenuItem_acceleratorSelectionForeground("CheckBoxMenuItem.acceleratorSelectionForeground"),
    CheckBoxMenuItem_arrowIcon("CheckBoxMenuItem.arrowIcon"),
    CheckBoxMenuItem_background("CheckBoxMenuItem.background"),
    CheckBoxMenuItem_border("CheckBoxMenuItem.border"),
    CheckBoxMenuItem_borderPainted("CheckBoxMenuItem.borderPainted"),
    CheckBoxMenuItem_checkIcon("CheckBoxMenuItem.checkIcon"),
    CheckBoxMenuItem_commandSound("CheckBoxMenuItem.commandSound"),
    CheckBoxMenuItem_disabledForeground("CheckBoxMenuItem.disabledForeground"),
    CheckBoxMenuItem_font("CheckBoxMenuItem.font"),
    CheckBoxMenuItem_foreground("CheckBoxMenuItem.foreground"),
    CheckBoxMenuItem_gradient("CheckBoxMenuItem.gradient"),
    CheckBoxMenuItem_margin("CheckBoxMenuItem.margin"),
    CheckBoxMenuItem_selectionBackground("CheckBoxMenuItem.selectionBackground"),
    CheckBoxMenuItem_selectionForeground("CheckBoxMenuItem.selectionForeground"),
    CheckBoxMenuItemUI("CheckBoxMenuItemUI"),
    CheckBoxUI("CheckBoxUI"),
    ColorChooser_background("ColorChooser.background"),
    ColorChooser_font("ColorChooser.font"),
    ColorChooser_foreground("ColorChooser.foreground"),
    ColorChooser_swatchesDefaultRecentColor("ColorChooser.swatchesDefaultRecentColor"),
    ColorChooser_swatchesRecentSwatchSize("ColorChooser.swatchesRecentSwatchSize"),
    ColorChooser_swatchesSwatchSize("ColorChooser.swatchesSwatchSize"),
    ColorChooserUI("ColorChooserUI"),
    ComboBox_ancestorInputMap("ComboBox.ancestorInputMap"),
    ComboBox_background("ComboBox.background"),
    ComboBox_buttonBackground("ComboBox.buttonBackground"),
    ComboBox_buttonDarkShadow("ComboBox.buttonDarkShadow"),
    ComboBox_buttonHighlight("ComboBox.buttonHighlight"),
    ComboBox_buttonShadow("ComboBox.buttonShadow"),
    ComboBox_disabledBackground("ComboBox.disabledBackground"),
    ComboBox_disabledForeground("ComboBox.disabledForeground"),
    ComboBox_font("ComboBox.font"),
    ComboBox_foreground("ComboBox.foreground"),
    ComboBox_isEnterSelectablePopup("ComboBox.isEnterSelectablePopup"),
    ComboBox_selectionBackground("ComboBox.selectionBackground"),
    ComboBox_selectionForeground("ComboBox.selectionForeground"),
    ComboBox_timeFactor("ComboBox.timeFactor"),
    ComboBoxUI("ComboBoxUI"),
    control("control"),
    controlDkShadow("controlDkShadow"),
    controlHighlight("controlHighlight"),
    controlLtHighlight("controlLtHighlight"),
    controlShadow("controlShadow"),
    controlText("controlText"),
    desktop("desktop"),
    Desktop_ancestorInputMap("Desktop.ancestorInputMap"),
    Desktop_background("Desktop.background"),
    Desktop_minOnScreenInsets("Desktop.minOnScreenInsets"),
    DesktopIcon_background("DesktopIcon.background"),
    DesktopIcon_border("DesktopIcon.border"),
    DesktopIcon_font("DesktopIcon.font"),
    DesktopIcon_foreground("DesktopIcon.foreground"),
    DesktopIcon_width("DesktopIcon.width"),
    DesktopIconUI("DesktopIconUI"),
    DesktopPaneUI("DesktopPaneUI"),
    EditorPane_background("EditorPane.background"),
    EditorPane_border("EditorPane.border"),
    EditorPane_caretBlinkRate("EditorPane.caretBlinkRate"),
    EditorPane_caretForeground("EditorPane.caretForeground"),
    EditorPane_focusInputMap("EditorPane.focusInputMap"),
    EditorPane_font("EditorPane.font"),
    EditorPane_foreground("EditorPane.foreground"),
    EditorPane_inactiveForeground("EditorPane.inactiveForeground"),
    EditorPane_margin("EditorPane.margin"),
    EditorPane_selectionBackground("EditorPane.selectionBackground"),
    EditorPane_selectionForeground("EditorPane.selectionForeground"),
    EditorPaneUI("EditorPaneUI"),
    FileChooser_ancestorInputMap("FileChooser.ancestorInputMap"),
    FileChooser_detailsViewIcon("FileChooser.detailsViewIcon"),
    FileChooser_fileNameLabelMnemonic("FileChooser.fileNameLabelMnemonic"),
    FileChooser_filesOfTypeLabelMnemonic("FileChooser.filesOfTypeLabelMnemonic"),
    FileChooser_homeFolderIcon("FileChooser.homeFolderIcon"),
    FileChooser_listViewIcon("FileChooser.listViewIcon"),
    FileChooser_lookInLabelMnemonic("FileChooser.lookInLabelMnemonic"),
    FileChooser_newFolderIcon("FileChooser.newFolderIcon"),
    FileChooser_readOnly("FileChooser.readOnly"),
    FileChooser_upFolderIcon("FileChooser.upFolderIcon"),
    FileChooser_usesSingleFilePane("FileChooser.usesSingleFilePane"),
    FileChooser_useSystemExtensionHiding("FileChooser.useSystemExtensionHiding"),
    FileChooserUI("FileChooserUI"),
    FileView_computerIcon("FileView.computerIcon"),
    FileView_directoryIcon("FileView.directoryIcon"),
    FileView_fileIcon("FileView.fileIcon"),
    FileView_floppyDriveIcon("FileView.floppyDriveIcon"),
    FileView_hardDriveIcon("FileView.hardDriveIcon"),
    FormattedTextField_background("FormattedTextField.background"),
    FormattedTextField_border("FormattedTextField.border"),
    FormattedTextField_caretBlinkRate("FormattedTextField.caretBlinkRate"),
    FormattedTextField_caretForeground("FormattedTextField.caretForeground"),
    FormattedTextField_focusInputMap("FormattedTextField.focusInputMap"),
    FormattedTextField_font("FormattedTextField.font"),
    FormattedTextField_foreground("FormattedTextField.foreground"),
    FormattedTextField_inactiveBackground("FormattedTextField.inactiveBackground"),
    FormattedTextField_inactiveForeground("FormattedTextField.inactiveForeground"),
    FormattedTextField_margin("FormattedTextField.margin"),
    FormattedTextField_selectionBackground("FormattedTextField.selectionBackground"),
    FormattedTextField_selectionForeground("FormattedTextField.selectionForeground"),
    FormattedTextFieldUI("FormattedTextFieldUI"),
    html_missingImage("html.missingImage"),
    html_pendingImage("html.pendingImage"),
    inactiveCaption("inactiveCaption"),
    inactiveCaptionBorder("inactiveCaptionBorder"),
    inactiveCaptionText("inactiveCaptionText"),
    info("info"),
    infoText("infoText"),
    InternalFrame_activeTitleBackground("InternalFrame.activeTitleBackground"),
    InternalFrame_activeTitleForeground("InternalFrame.activeTitleForeground"),
    InternalFrame_activeTitleGradient("InternalFrame.activeTitleGradient"),
    InternalFrame_border("InternalFrame.border"),
    InternalFrame_borderColor("InternalFrame.borderColor"),
    InternalFrame_borderDarkShadow("InternalFrame.borderDarkShadow"),
    InternalFrame_borderHighlight("InternalFrame.borderHighlight"),
    InternalFrame_borderLight("InternalFrame.borderLight"),
    InternalFrame_borderShadow("InternalFrame.borderShadow"),
    InternalFrame_closeIcon("InternalFrame.closeIcon"),
    InternalFrame_closeSound("InternalFrame.closeSound"),
    InternalFrame_icon("InternalFrame.icon"),
    InternalFrame_iconifyIcon("InternalFrame.iconifyIcon"),
    InternalFrame_inactiveTitleBackground("InternalFrame.inactiveTitleBackground"),
    InternalFrame_inactiveTitleForeground("InternalFrame.inactiveTitleForeground"),
    InternalFrame_maximizeIcon("InternalFrame.maximizeIcon"),
    InternalFrame_maximizeSound("InternalFrame.maximizeSound"),
    InternalFrame_minimizeIcon("InternalFrame.minimizeIcon"),
    InternalFrame_minimizeSound("InternalFrame.minimizeSound"),
    InternalFrame_optionDialogBorder("InternalFrame.optionDialogBorder"),
    InternalFrame_paletteBorder("InternalFrame.paletteBorder"),
    InternalFrame_paletteCloseIcon("InternalFrame.paletteCloseIcon"),
    InternalFrame_paletteTitleHeight("InternalFrame.paletteTitleHeight"),
    InternalFrame_restoreDownSound("InternalFrame.restoreDownSound"),
    InternalFrame_restoreUpSound("InternalFrame.restoreUpSound"),
    InternalFrame_titleFont("InternalFrame.titleFont"),
    InternalFrameTitlePane_closeButtonOpacity("InternalFrameTitlePane.closeButtonOpacity"),
    InternalFrameTitlePane_iconifyButtonOpacity("InternalFrameTitlePane.iconifyButtonOpacity"),
    InternalFrameTitlePane_maximizeButtonOpacity("InternalFrameTitlePane.maximizeButtonOpacity"),
    InternalFrameUI("InternalFrameUI"),
    Label_background("Label.background"),
    Label_disabledForeground("Label.disabledForeground"),
    Label_disabledShadow("Label.disabledShadow"),
    Label_font("Label.font"),
    Label_foreground("Label.foreground"),
    LabelUI("LabelUI"),
    List_background("List.background"),
    List_cellRenderer("List.cellRenderer"),
    List_dropCellBackground("List.dropCellBackground"),
    List_dropLineColor("List.dropLineColor"),
    List_focusCellHighlightBorder("List.focusCellHighlightBorder"),
    List_focusInputMap("List.focusInputMap"),
    List_focusInputMap_RightToLeft("List.focusInputMap.RightToLeft"),
    List_font("List.font"),
    List_foreground("List.foreground"),
    List_selectionBackground("List.selectionBackground"),
    List_selectionForeground("List.selectionForeground"),
    List_timeFactor("List.timeFactor"),
    ListUI("ListUI"),
    menu("menu"),
    Menu_acceleratorFont("Menu.acceleratorFont"),
    Menu_acceleratorForeground("Menu.acceleratorForeground"),
    Menu_acceleratorSelectionForeground("Menu.acceleratorSelectionForeground"),
    Menu_arrowIcon("Menu.arrowIcon"),
    Menu_background("Menu.background"),
    Menu_border("Menu.border"),
    Menu_borderPainted("Menu.borderPainted"),
    Menu_checkIcon("Menu.checkIcon"),
    Menu_crossMenuMnemonic("Menu.crossMenuMnemonic"),
    Menu_disabledForeground("Menu.disabledForeground"),
    Menu_font("Menu.font"),
    Menu_foreground("Menu.foreground"),
    Menu_margin("Menu.margin"),
    Menu_menuPopupOffsetX("Menu.menuPopupOffsetX"),
    Menu_menuPopupOffsetY("Menu.menuPopupOffsetY"),
    Menu_opaque("Menu.opaque"),
    Menu_selectionBackground("Menu.selectionBackground"),
    Menu_selectionForeground("Menu.selectionForeground"),
    Menu_shortcutKeys("Menu.shortcutKeys"),
    Menu_submenuPopupOffsetX("Menu.submenuPopupOffsetX"),
    Menu_submenuPopupOffsetY("Menu.submenuPopupOffsetY"),
    MenuBar_background("MenuBar.background"),
    MenuBar_border("MenuBar.border"),
    MenuBar_borderColor("MenuBar.borderColor"),
    MenuBar_font("MenuBar.font"),
    MenuBar_foreground("MenuBar.foreground"),
    MenuBar_gradient("MenuBar.gradient"),
    MenuBar_highlight("MenuBar.highlight"),
    MenuBar_shadow("MenuBar.shadow"),
    MenuBar_windowBindings("MenuBar.windowBindings"),
    MenuBarUI("MenuBarUI"),
    MenuItem_acceleratorDelimiter("MenuItem.acceleratorDelimiter"),
    MenuItem_acceleratorFont("MenuItem.acceleratorFont"),
    MenuItem_acceleratorForeground("MenuItem.acceleratorForeground"),
    MenuItem_acceleratorSelectionForeground("MenuItem.acceleratorSelectionForeground"),
    MenuItem_arrowIcon("MenuItem.arrowIcon"),
    MenuItem_background("MenuItem.background"),
    MenuItem_border("MenuItem.border"),
    MenuItem_borderPainted("MenuItem.borderPainted"),
    MenuItem_checkIcon("MenuItem.checkIcon"),
    MenuItem_commandSound("MenuItem.commandSound"),
    MenuItem_disabledForeground("MenuItem.disabledForeground"),
    MenuItem_font("MenuItem.font"),
    MenuItem_foreground("MenuItem.foreground"),
    MenuItem_margin("MenuItem.margin"),
    MenuItem_selectionBackground("MenuItem.selectionBackground"),
    MenuItem_selectionForeground("MenuItem.selectionForeground"),
    MenuItemUI("MenuItemUI"),
    menuText("menuText"),
    MenuUI("MenuUI"),
    OptionPane_background("OptionPane.background"),
    OptionPane_border("OptionPane.border"),
    OptionPane_buttonAreaBorder("OptionPane.buttonAreaBorder"),
    OptionPane_buttonClickThreshhold("OptionPane.buttonClickThreshhold"),
    OptionPane_errorDialog_border_background("OptionPane.errorDialog.border.background"),
    OptionPane_errorDialog_titlePane_background("OptionPane.errorDialog.titlePane.background"),
    OptionPane_errorDialog_titlePane_foreground("OptionPane.errorDialog.titlePane.foreground"),
    OptionPane_errorDialog_titlePane_shadow("OptionPane.errorDialog.titlePane.shadow"),
    OptionPane_errorIcon("OptionPane.errorIcon"),
    OptionPane_errorSound("OptionPane.errorSound"),
    OptionPane_font("OptionPane.font"),
    OptionPane_foreground("OptionPane.foreground"),
    OptionPane_informationIcon("OptionPane.informationIcon"),
    OptionPane_informationSound("OptionPane.informationSound"),
    OptionPane_messageAreaBorder("OptionPane.messageAreaBorder"),
    OptionPane_messageForeground("OptionPane.messageForeground"),
    OptionPane_minimumSize("OptionPane.minimumSize"),
    OptionPane_questionDialog_border_background("OptionPane.questionDialog.border.background"),
    OptionPane_questionDialog_titlePane_background("OptionPane.questionDialog.titlePane.background"),
    OptionPane_questionDialog_titlePane_foreground("OptionPane.questionDialog.titlePane.foreground"),
    OptionPane_questionDialog_titlePane_shadow("OptionPane.questionDialog.titlePane.shadow"),
    OptionPane_questionIcon("OptionPane.questionIcon"),
    OptionPane_questionSound("OptionPane.questionSound"),
    OptionPane_warningDialog_border_background("OptionPane.warningDialog.border.background"),
    OptionPane_warningDialog_titlePane_background("OptionPane.warningDialog.titlePane.background"),
    OptionPane_warningDialog_titlePane_foreground("OptionPane.warningDialog.titlePane.foreground"),
    OptionPane_warningDialog_titlePane("OptionPane.warningDialog.titlePane.shadow"),
    OptionPane_warningIcon("OptionPane.warningIcon"),
    OptionPane_warningSound("OptionPane.warningSound"),
    OptionPane_windowBindings("OptionPane.windowBindings"),
    OptionPaneUI("OptionPaneUI"),
    Panel_background("Panel.background"),
    Panel_font("Panel.font"),
    Panel_foreground("Panel.foreground"),
    PanelUI("PanelUI"),
    PasswordField_background("PasswordField.background"),
    PasswordField_border("PasswordField.border"),
    PasswordField_caretBlinkRate("PasswordField.caretBlinkRate"),
    PasswordField_caretForeground("PasswordField.caretForeground"),
    PasswordField_echoChar("PasswordField.echoChar"),
    PasswordField_focusInputMap("PasswordField.focusInputMap"),
    PasswordField_font("PasswordField.font"),
    PasswordField_foreground("PasswordField.foreground"),
    PasswordField_inactiveBackground("PasswordField.inactiveBackground"),
    PasswordField_inactiveForeground("PasswordField.inactiveForeground"),
    PasswordField_margin("PasswordField.margin"),
    PasswordField_selectionBackground("PasswordField.selectionBackground"),
    PasswordField_selectionForeground("PasswordField.selectionForeground"),
    PasswordFieldUI("PasswordFieldUI"),
    PopupMenu_background("PopupMenu.background"),
    PopupMenu_border("PopupMenu.border"),
    PopupMenu_consumeEventOnClose("PopupMenu.consumeEventOnClose"),
    PopupMenu_font("PopupMenu.font"),
    PopupMenu_foreground("PopupMenu.foreground"),
    PopupMenu_popupSound("PopupMenu.popupSound"),
    PopupMenu_selectedWindowInputMapBindings("PopupMenu.selectedWindowInputMapBindings"),
    PopupMenu_selectedWindowInputMapBindings_RightToLeft("PopupMenu.selectedWindowInputMapBindings.RightToLeft"),
    PopupMenuSeparatorUI("PopupMenuSeparatorUI"),
    PopupMenuUI("PopupMenuUI"),
    ProgressBar_background("ProgressBar.background"),
    ProgressBar_border("ProgressBar.border"),
    ProgressBar_cellLength("ProgressBar.cellLength"),
    ProgressBar_cellSpacing("ProgressBar.cellSpacing"),
    ProgressBar_cycleTime("ProgressBar.cycleTime"),
    ProgressBar_font("ProgressBar.font"),
    ProgressBar_foreground("ProgressBar.foreground"),
    ProgressBar_horizontalSize("ProgressBar.horizontalSize"),
    ProgressBar_repaintInterval("ProgressBar.repaintInterval"),
    ProgressBar_selectionBackground("ProgressBar.selectionBackground"),
    ProgressBar_selectionForeground("ProgressBar.selectionForeground"),
    ProgressBar_verticalSize("ProgressBar.verticalSize"),
    ProgressBarUI("ProgressBarUI"),
    RadioButton_background("RadioButton.background"),
    RadioButton_border("RadioButton.border"),
    RadioButton_darkShadow("RadioButton.darkShadow"),
    RadioButton_disabledText("RadioButton.disabledText"),
    RadioButton_focus("RadioButton.focus"),
    RadioButton_focusInputMap("RadioButton.focusInputMap"),
    RadioButton_font("RadioButton.font"),
    RadioButton_foreground("RadioButton.foreground"),
    RadioButton_gradient("RadioButton.gradient"),
    RadioButton_highlight("RadioButton.highlight"),
    RadioButton_icon("RadioButton.icon"),
    RadioButton_light("RadioButton.light"),
    RadioButton_margin("RadioButton.margin"),
    RadioButton_rollover("RadioButton.rollover"),
    RadioButton_select("RadioButton.select"),
    RadioButton_shadow("RadioButton.shadow"),
    RadioButton_textIconGap("RadioButton.textIconGap"),
    RadioButton_textShiftOffset("RadioButton.textShiftOffset"),
    RadioButton_totalInsets("RadioButton.totalInsets"),
    RadioButtonMenuItem_acceleratorFont("RadioButtonMenuItem.acceleratorFont"),
    RadioButtonMenuItem_acceleratorForeground("RadioButtonMenuItem.acceleratorForeground"),
    RadioButtonMenuItem_acceleratorSelectionForeground("RadioButtonMenuItem.acceleratorSelectionForeground"),
    RadioButtonMenuItem_arrowIcon("RadioButtonMenuItem.arrowIcon"),
    RadioButtonMenuItem_background("RadioButtonMenuItem.background"),
    RadioButtonMenuItem_border("RadioButtonMenuItem.border"),
    RadioButtonMenuItem_borderPainted("RadioButtonMenuItem.borderPainted"),
    RadioButtonMenuItem_checkIcon("RadioButtonMenuItem.checkIcon"),
    RadioButtonMenuItem_commandSound("RadioButtonMenuItem.commandSound"),
    RadioButtonMenuItem_disabledForeground("RadioButtonMenuItem.disabledForeground"),
    RadioButtonMenuItem_font("RadioButtonMenuItem.font"),
    RadioButtonMenuItem_foreground("RadioButtonMenuItem.foreground"),
    RadioButtonMenuItem_gradient("RadioButtonMenuItem.gradient"),
    RadioButtonMenuItem_margin("RadioButtonMenuItem.margin"),
    RadioButtonMenuItem_selectionBackground("RadioButtonMenuItem.selectionBackground"),
    RadioButtonMenuItem_selectionForeground("RadioButtonMenuItem.selectionForeground"),
    RadioButtonMenuItemUI("RadioButtonMenuItemUI"),
    RadioButtonUI("RadioButtonUI"),
    RootPane_ancestorInputMap("RootPane.ancestorInputMap"),
    RootPane_colorChooserDialogBorder("RootPane.colorChooserDialogBorder"),
    RootPane_defaultButtonWindowKeyBindings("RootPane.defaultButtonWindowKeyBindings"),
    RootPane_errorDialogBorder("RootPane.errorDialogBorder"),
    RootPane_fileChooserDialogBorder("RootPane.fileChooserDialogBorder"),
    RootPane_frameBorder("RootPane.frameBorder"),
    RootPane_informationDialogBorder("RootPane.informationDialogBorder"),
    RootPane_plainDialogBorder("RootPane.plainDialogBorder"),
    RootPane_questionDialogBorder("RootPane.questionDialogBorder"),
    RootPane_warningDialogBorder("RootPane.warningDialogBorder"),
    RootPaneUI("RootPaneUI"),
    scrollbar("scrollbar"),
    ScrollBar_allowsAbsolutePositioning("ScrollBar.allowsAbsolutePositioning"),
    ScrollBar_ancestorInputMap("ScrollBar.ancestorInputMap"),
    ScrollBar_ancestorInputMap_RightToLeft("ScrollBar.ancestorInputMap.RightToLeft"),
    ScrollBar_background("ScrollBar.background"),
    ScrollBar_darkShadow("ScrollBar.darkShadow"),
    ScrollBar_foreground("ScrollBar.foreground"),
    ScrollBar_gradient("ScrollBar.gradient"),
    ScrollBar_highlight("ScrollBar.highlight"),
    ScrollBar_maximumThumbSize("ScrollBar.maximumThumbSize"),
    ScrollBar_minimumThumbSize("ScrollBar.minimumThumbSize"),
    ScrollBar_shadow("ScrollBar.shadow"),
    ScrollBar_thumb("ScrollBar.thumb"),
    ScrollBar_thumbDarkShadow("ScrollBar.thumbDarkShadow"),
    ScrollBar_thumbHighlight("ScrollBar.thumbHighlight"),
    ScrollBar_thumbShadow("ScrollBar.thumbShadow"),
    ScrollBar_track("ScrollBar.track"),
    ScrollBar_trackHighlight("ScrollBar.trackHighlight"),
    ScrollBar_width("ScrollBar.width"),
    ScrollBarUI("ScrollBarUI"),
    ScrollPane_ancestorInputMap("ScrollPane.ancestorInputMap"),
    ScrollPane_ancestorInputMap_RightToLeft("ScrollPane.ancestorInputMap.RightToLeft"),
    ScrollPane_background("ScrollPane.background"),
    ScrollPane_border("ScrollPane.border"),
    ScrollPane_font("ScrollPane.font"),
    ScrollPane_foreground("ScrollPane.foreground"),
    ScrollPaneUI("ScrollPaneUI"),
    Separator_background("Separator.background"),
    Separator_foreground("Separator.foreground"),
    Separator_highlight("Separator.highlight"),
    Separator_shadow("Separator.shadow"),
    SeparatorUI("SeparatorUI"),
    Slider_altTrackColor("Slider.altTrackColor"),
    Slider_background("Slider.background"),
    Slider_focus("Slider.focus"),
    Slider_focusGradient("Slider.focusGradient"),
    Slider_focusInputMap("Slider.focusInputMap"),
    Slider_focusInputMap_RightToLeft("Slider.focusInputMap.RightToLeft"),
    Slider_focusInsets("Slider.focusInsets"),
    Slider_font("Slider.font"),
    Slider_foreground("Slider.foreground"),
    Slider_gradient("Slider.gradient"),
    Slider_highlight("Slider.highlight"),
    Slider_horizontalSize("Slider.horizontalSize"),
    Slider_horizontalThumbIcon("Slider.horizontalThumbIcon"),
    Slider_majorTickLength("Slider.majorTickLength"),
    Slider_minimumHorizontalSize("Slider.minimumHorizontalSize"),
    Slider_minimumVerticalSize("Slider.minimumVerticalSize"),
    Slider_shadow("Slider.shadow"),
    Slider_tickColor("Slider.tickColor"),
    Slider_trackWidth("Slider.trackWidth"),
    Slider_verticalSize("Slider.verticalSize"),
    Slider_verticalThumbIcon("Slider.verticalThumbIcon"),
    SliderUI("SliderUI"),
    Spinner_ancestorInputMap("Spinner.ancestorInputMap"),
    Spinner_arrowButtonBorder("Spinner.arrowButtonBorder"),
    Spinner_arrowButtonInsets("Spinner.arrowButtonInsets"),
    Spinner_arrowButtonSize("Spinner.arrowButtonSize"),
    Spinner_background("Spinner.background"),
    Spinner_border("Spinner.border"),
    Spinner_editorAlignment("Spinner.editorAlignment"),
    Spinner_editorBorderPainted("Spinner.editorBorderPainted"),
    Spinner_font("Spinner.font"),
    Spinner_foreground("Spinner.foreground"),
    SpinnerUI("SpinnerUI"),
    SplitPane_ancestorInputMap("SplitPane.ancestorInputMap"),
    SplitPane_background("SplitPane.background"),
    SplitPane_border("SplitPane.border"),
    SplitPane_centerOneTouchButtons("SplitPane.centerOneTouchButtons"),
    SplitPane_darkShadow("SplitPane.darkShadow"),
    SplitPane_dividerFocusColor("SplitPane.dividerFocusColor"),
    SplitPane_dividerSize("SplitPane.dividerSize"),
    SplitPane_highlight("SplitPane.highlight"),
    SplitPane_oneTouchButtonsOpaque("SplitPane.oneTouchButtonsOpaque"),
    SplitPane_shadow("SplitPane.shadow"),
    SplitPaneDivider_border("SplitPaneDivider.border"),
    SplitPaneDivider_draggingColor("SplitPaneDivider.draggingColor"),
    SplitPaneUI("SplitPaneUI"),
    TabbedPane_ancestorInputMap("TabbedPane.ancestorInputMap"),
    TabbedPane_background("TabbedPane.background"),
    TabbedPane_borderHightlightColor("TabbedPane.borderHightlightColor"),
    TabbedPane_contentAreaColor("TabbedPane.contentAreaColor"),
    TabbedPane_contentBorderInsets("TabbedPane.contentBorderInsets"),
    TabbedPane_contentOpaque("TabbedPane.contentOpaque"),
    TabbedPane_darkShadow("TabbedPane.darkShadow"),
    TabbedPane_focus("TabbedPane.focus"),
    TabbedPane_focusInputMap("TabbedPane.focusInputMap"),
    TabbedPane_font("TabbedPane.font"),
    TabbedPane_foreground("TabbedPane.foreground"),
    TabbedPane_highlight("TabbedPane.highlight"),
    TabbedPane_light("TabbedPane.light"),
    TabbedPane_selected("TabbedPane.selected"),
    TabbedPane_selectedTabPadInsets("TabbedPane.selectedTabPadInsets"),
    TabbedPane_selectHighlight("TabbedPane.selectHighlight"),
    TabbedPane_shadow("TabbedPane.shadow"),
    TabbedPane_tabAreaBackground("TabbedPane.tabAreaBackground"),
    TabbedPane_tabAreaInsets("TabbedPane.tabAreaInsets"),
    TabbedPane_tabInsets("TabbedPane.tabInsets"),
    TabbedPane_tabRunOverlay("TabbedPane.tabRunOverlay"),
    TabbedPane_tabsOpaque("TabbedPane.tabsOpaque"),
    TabbedPane_tabsOverlapBorder("TabbedPane.tabsOverlapBorder"),
    TabbedPane_textIconGap("TabbedPane.textIconGap"),
    TabbedPane_unselectedBackground("TabbedPane.unselectedBackground"),
    TabbedPaneUI("TabbedPaneUI"),
    Table_ancestorInputMap("Table.ancestorInputMap"),
    Table_ancestorInputMap_RightToLeft("Table.ancestorInputMap.RightToLeft"),
    Table_ascendingSortIcon("Table.ascendingSortIcon"),
    Table_background("Table.background"),
    Table_descendingSortIcon("Table.descendingSortIcon"),
    Table_dropCellBackground("Table.dropCellBackground"),
    Table_dropLineColor("Table.dropLineColor"),
    Table_dropLineShortColor("Table.dropLineShortColor"),
    Table_focusCellBackground("Table.focusCellBackground"),
    Table_focusCellForeground("Table.focusCellForeground"),
    Table_focusCellHighlightBorder("Table.focusCellHighlightBorder"),
    Table_font("Table.font"),
    Table_foreground("Table.foreground"),
    Table_gridColor("Table.gridColor"),
    Table_scrollPaneBorder("Table.scrollPaneBorder"),
    Table_selectionBackground("Table.selectionBackground"),
    Table_selectionForeground("Table.selectionForeground"),
    Table_sortIconColor("Table.sortIconColor"),
    TableHeader_ancestorInputMap("TableHeader.ancestorInputMap"),
    TableHeader_background("TableHeader.background"),
    TableHeader_cellBorder("TableHeader.cellBorder"),
    TableHeader_focusCellBackground("TableHeader.focusCellBackground"),
    TableHeader_font("TableHeader.font"),
    TableHeader_foreground("TableHeader.foreground"),
    TableHeaderUI("TableHeaderUI"),
    TableUI("TableUI"),
    text("text"),
    TextArea_background("TextArea.background"),
    TextArea_border("TextArea.border"),
    TextArea_caretBlinkRate("TextArea.caretBlinkRate"),
    TextArea_caretForeground("TextArea.caretForeground"),
    TextArea_focusInputMap("TextArea.focusInputMap"),
    TextArea_font("TextArea.font"),
    TextArea_foreground("TextArea.foreground"),
    TextArea_inactiveForeground("TextArea.inactiveForeground"),
    TextArea_margin("TextArea.margin"),
    TextArea_selectionBackground("TextArea.selectionBackground"),
    TextArea_selectionForeground("TextArea.selectionForeground"),
    TextAreaUI("TextAreaUI"),
    TextField_background("TextField.background"),
    TextField_border("TextField.border"),
    TextField_caretBlinkRate("TextField.caretBlinkRate"),
    TextField_caretForeground("TextField.caretForeground"),
    TextField_darkShadow("TextField.darkShadow"),
    TextField_focusInputMap("TextField.focusInputMap"),
    TextField_font("TextField.font"),
    TextField_foreground("TextField.foreground"),
    TextField_highlight("TextField.highlight"),
    TextField_inactiveBackground("TextField.inactiveBackground"),
    TextField_inactiveForeground("TextField.inactiveForeground"),
    TextField_light("TextField.light"),
    TextField_margin("TextField.margin"),
    TextField_selectionBackground("TextField.selectionBackground"),
    TextField_selectionForeground("TextField.selectionForeground"),
    TextField_shadow("TextField.shadow"),
    TextFieldUI("TextFieldUI"),
    textHighlight("textHighlight"),
    textHighlightText("textHighlightText"),
    textInactiveText("textInactiveText"),
    TextPane_background("TextPane.background"),
    TextPane_border("TextPane.border"),
    TextPane_caretBlinkRate("TextPane.caretBlinkRate"),
    TextPane_caretForeground("TextPane.caretForeground"),
    TextPane_focusInputMap("TextPane.focusInputMap"),
    TextPane_font("TextPane.font"),
    TextPane_foreground("TextPane.foreground"),
    TextPane_inactiveForeground("TextPane.inactiveForeground"),
    TextPane_margin("TextPane.margin"),
    TextPane_selectionBackground("TextPane.selectionBackground"),
    TextPane_selectionForeground("TextPane.selectionForeground"),
    TextPaneUI("TextPaneUI"),
    textText("textText"),
    TitledBorder_border("TitledBorder.border"),
    TitledBorder_font("TitledBorder.font"),
    TitledBorder_titleColor("TitledBorder.titleColor"),
    ToggleButton_background("ToggleButton.background"),
    ToggleButton_border("ToggleButton.border"),
    ToggleButton_darkShadow("ToggleButton.darkShadow"),
    ToggleButton_disabledText("ToggleButton.disabledText"),
    ToggleButton_focus("ToggleButton.focus"),
    ToggleButton_focusInputMap("ToggleButton.focusInputMap"),
    ToggleButton_font("ToggleButton.font"),
    ToggleButton_foreground("ToggleButton.foreground"),
    ToggleButton_gradient("ToggleButton.gradient"),
    ToggleButton_highlight("ToggleButton.highlight"),
    ToggleButton_light("ToggleButton.light"),
    ToggleButton_margin("ToggleButton.margin"),
    ToggleButton_select("ToggleButton.select"),
    ToggleButton_shadow("ToggleButton.shadow"),
    ToggleButton_textIconGap("ToggleButton.textIconGap"),
    ToggleButton_textShiftOffset("ToggleButton.textShiftOffset"),
    ToggleButtonUI("ToggleButtonUI"),
    ToolBar_ancestorInputMap("ToolBar.ancestorInputMap"),
    ToolBar_background("ToolBar.background"),
    ToolBar_border("ToolBar.border"),
    ToolBar_borderColor("ToolBar.borderColor"),
    ToolBar_darkShadow("ToolBar.darkShadow"),
    ToolBar_dockingBackground("ToolBar.dockingBackground"),
    ToolBar_dockingForeground("ToolBar.dockingForeground"),
    ToolBar_floatingBackground("ToolBar.floatingBackground"),
    ToolBar_floatingForeground("ToolBar.floatingForeground"),
    ToolBar_font("ToolBar.font"),
    ToolBar_foreground("ToolBar.foreground"),
    ToolBar_highlight("ToolBar.highlight"),
    ToolBar_isRollover("ToolBar.isRollover"),
    ToolBar_light("ToolBar.light"),
    ToolBar_nonrolloverBorder("ToolBar.nonrolloverBorder"),
    ToolBar_rolloverBorder("ToolBar.rolloverBorder"),
    ToolBar_separatorSize("ToolBar.separatorSize"),
    ToolBar_shadow("ToolBar.shadow"),
    ToolBarSeparatorUI("ToolBarSeparatorUI"),
    ToolBarUI("ToolBarUI"),
    ToolTip_background("ToolTip.background"),
    ToolTip_backgroundInactive("ToolTip.backgroundInactive"),
    ToolTip_border("ToolTip.border"),
    ToolTip_borderInactive("ToolTip.borderInactive"),
    ToolTip_font("ToolTip.font"),
    ToolTip_foreground("ToolTip.foreground"),
    ToolTip_foregroundInactive("ToolTip.foregroundInactive"),
    ToolTip_hideAccelerator("ToolTip.hideAccelerator"),
    ToolTipManager_enableToolTipMode("ToolTipManager.enableToolTipMode"),
    ToolTipUI("ToolTipUI"),
    Tree_ancestorInputMap("Tree.ancestorInputMap"),
    Tree_background("Tree.background"),
    Tree_changeSelectionWithFocus("Tree.changeSelectionWithFocus"),
    Tree_closedIcon("Tree.closedIcon"),
    Tree_collapsedIcon("Tree.collapsedIcon"),
    Tree_drawsFocusBorderAroundIcon("Tree.drawsFocusBorderAroundIcon"),
    Tree_dropCellBackground("Tree.dropCellBackground"),
    Tree_dropLineColor("Tree.dropLineColor"),
    Tree_editorBorder("Tree.editorBorder"),
    Tree_expandedIcon("Tree.expandedIcon"),
    Tree_focusInputMap("Tree.focusInputMap"),
    Tree_focusInputMap_RightToLeft("Tree.focusInputMap.RightToLeft"),
    Tree_font("Tree.font"),
    Tree_foreground("Tree.foreground"),
    Tree_hash("Tree.hash"),
    Tree_leafIcon("Tree.leafIcon"),
    Tree_leftChildIndent("Tree.leftChildIndent"),
    Tree_line("Tree.line"),
    Tree_lineTypeDashed("Tree.lineTypeDashed"),
    Tree_openIcon("Tree.openIcon"),
    Tree_paintLines("Tree.paintLines"),
    Tree_rightChildIndent("Tree.rightChildIndent"),
    Tree_rowHeight("Tree.rowHeight"),
    Tree_scrollsOnExpand("Tree.scrollsOnExpand"),
    Tree_selectionBackground("Tree.selectionBackground"),
    Tree_selectionBorderColor("Tree.selectionBorderColor"),
    Tree_selectionForeground("Tree.selectionForeground"),
    Tree_textBackground("Tree.textBackground"),
    Tree_textForeground("Tree.textForeground"),
    Tree_timeFactor("Tree.timeFactor"),
    TreeUI("TreeUI"),
    Viewport_background("Viewport.background"),
    Viewport_font("Viewport.font"),
    Viewport_foreground("Viewport.foreground"),
    ViewportUI("ViewportUI"),
    window("window"),
    windowBorder("windowBorder"),
    windowText("windowText");

    private final String key;

    private UIManagerKey(String key)
    {
        this.key = key;
    }

    public String getKey()
    {
        return key;
    }

    @Override
    public String toString()
    {
        return key;
    }
    
    public static void main(String[] args)
    {
        UIDefaults d = UIManager.getDefaults();
        Enumeration e = d.keys();
        while (e.hasMoreElements()) {
            Object key = e.nextElement();
            System.out.println(key + ": " + d.get(key));
        }
    }
}
